﻿Imports System.Web.UI.WebControls.WebParts

Partial Class Default2
    Inherits System.Web.UI.Page

    Protected Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
        AddHandler Page.InitComplete, AddressOf GenerateModeList
    End Sub

    Protected Sub GenerateModeList(ByVal sender As Object, ByVal e As EventArgs)

        Dim _manager As WebPartManager = _
          WebPartManager.GetCurrentWebPartManager(Page)
        Dim browseModeName As String = webPartManager.BrowseDisplayMode.Name

        DropDownListModes.Items.Clear()

        'fill the drop-down list with the names of supported display modes. 
        For Each mode As webPartDisplayMode In _manager.SupportedDisplayModes

            Dim modeName As String = mode.Name

            'make sure a mode is enabled before adding it. 
            If mode.IsEnabled(_manager) Then
                Dim item As ListItem = New ListItem(modeName, modeName)
                DropDownListModes.Items.Add(item)
            End If

        Next

        'select the current mode 
        Dim items As ListItemCollection = DropDownListModes.Items
        Dim selectedIndex As Integer = _
          items.IndexOf(items.FindByText(_manager.DisplayMode.Name))

        DropDownListModes.SelectedIndex = selectedIndex
    End Sub

    Protected Sub DropDownListModes_SelectedIndexChanged(ByVal sender As Object, _
  ByVal e As EventArgs) Handles DropDownListModes.SelectedIndexChanged

        Dim manager As WebPartManager = _
          WebPartManager.GetCurrentWebPartManager(Page)
        Dim mode As WebPartDisplayMode = _
          manager.SupportedDisplayModes(DropDownListModes.SelectedValue)

        If Not (mode Is Nothing) Then
            manager.DisplayMode = mode
        End If

    End Sub

End Class
