﻿Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls

Public Class PassTextBox
    Inherits TextBox
    Implements IScriptControl

    Private _sMgr As ScriptManager

    Public WeakCssClass As String
    Public MediumCssClass As String
    Public StrongCssClass As String

    Protected Overridable Function GetScriptDescriptors() _
        As IEnumerable(Of ScriptDescriptor)

        Dim descriptor As ScriptControlDescriptor = _
            New ScriptControlDescriptor("AjaxEnabled.PassTextBox", Me.ClientID)

        descriptor.AddProperty("weakCssClass", Me.WeakCssClass)
        descriptor.AddProperty("mediumCssClass", Me.MediumCssClass)
        descriptor.AddProperty("strongCssClass", Me.StrongCssClass)

        Return New ScriptDescriptor() {descriptor}

    End Function

    Protected Overridable Function GetScriptReferences() _
        As IEnumerable(Of ScriptReference)

        Dim reference As ScriptReference = New ScriptReference()

        reference.Assembly = "AjaxEnabled"
        reference.Name = "AjaxEnabled.PassTextBox.js"

        Return New ScriptReference() {reference}

    End Function

    Protected Overrides Sub OnPreRender(ByVal e As EventArgs)
        If Not Me.DesignMode Then

            'test for the existence of a ScriptManager
            _sMgr = ScriptManager.GetCurrent(Page)

            If _sMgr Is Nothing Then _
                Throw New HttpException( _
                "A ScriptManager control must exist on the page.")

            _sMgr.RegisterScriptControl(Me)
        End If

        MyBase.OnPreRender(e)
    End Sub

    Protected Overrides Sub Render(ByVal writer As HtmlTextWriter)
        If Not Me.DesignMode Then _
          _sMgr.RegisterScriptDescriptors(Me)
        MyBase.Render(writer)
    End Sub
    Function IScriptControlGetScriptReferences() _
      As IEnumerable(Of ScriptReference) _
      Implements IScriptControl.GetScriptReferences

        Return GetScriptReferences()

    End Function

    Function IScriptControlGetScriptDescriptors() _
      As IEnumerable(Of ScriptDescriptor) _
      Implements IScriptControl.GetScriptDescriptors

        Return GetScriptDescriptors()

    End Function

End Class
