﻿Imports Microsoft.VisualBasic
Imports System.Xml.Linq

Public Class EmployeeServices

    Dim _empXml As XElement = XElement.Load( _
        "C:\Code\Lesson1-Exercise1-Completed-CS\LinqExample\App_Data\employees.xml")

    Public Function GetDepartments() As List(Of String)

        'query the XML and group by department
        '  select only the departments in the group
        Dim deptQuery =
            From emp In _empXml.Descendants("Employee")
            Group emp By emp.Element("Department").Value
            Into empGroup = Group
            Select empGroup.First().Element("Department").Value

        Return deptQuery.ToList()

    End Function

    Public Function GetEmployeesByDept(ByVal department As String) _
        As List(Of Employee)

        'query the XML list by department and return a list of 
        '  Employee(objects)
        Dim empQuery As IEnumerable(Of Employee) =
            From emp In _empXml.Descendants("Employee")
            Where emp.Element("Department").Value = department
            Select New Employee With {
                .Id = emp.Element("ID").Value,
                .Department = emp.Element("Department").Value,
                .FirstName = emp.Element("FirstName").Value,
                .LastName = emp.Element("LastName").Value,
                .Location = emp.Element("Location").Value
            }

        Return empQuery.ToList()

    End Function

End Class
